##########################################################################
### bishop.plugin.py
###

class Bishop(Task):

    id = 'BISHOP'
    tests = [
        Test(id='01', time=1.0, score=1, dat=None, chk=None),
        Test(id='02', time=1.0, score=1, dat=None, chk=None),
        Test(id='03', time=1.0, score=2, dat=None, chk=None),
        Test(id='04', time=1.0, score=2, dat=None, chk=None),
        Test(id='05', time=1.0, score=2, dat=None, chk=None),
        Test(id='06', time=1.0, score=2, dat=None, chk=None),
        Test(id='07', time=1.0, score=2, dat=None, chk=None),
        Test(id='08', time=1.0, score=2, dat=None, chk=None),
        Test(id='09', time=1.0, score=2, dat=None, chk=None),
        Test(id='10', time=1.0, score=2, dat=None, chk=None),
        Test(id='11', time=1.0, score=2, dat=None, chk=None),
    ]

    def load_dat(self, stream):
        M, N, X1, Y1, X2, Y2 = map(int, stream.readline().split())
        return Dat(M=M, N=N, X1=X1, Y1=Y1, X2=X2, Y2=Y2)

    def load_chk(self, stream):
        return Chk(moves=int(stream.readline()))

    def write_input(self, dat):
        self.write_line(dat.M, dat.N, dat.X1, dat.Y1, dat.X2, dat.Y2)

    def read_output(self, dat):
        moves = self.read_line(int)
        positions = []
        if moves > 1:
            for k in range(moves-1):
                X, Y = self.read_line(int, int)
                positions.append((X, Y))
        return Sol(moves=moves, positions=positions)

    def check(self, dat, chk, sol):
        if chk.moves != sol.moves:
            self.break_WA()
        if sol.moves == 0:
	    self.break_OK()
	X0, Y0 = dat.X1, dat.Y1
        for X, Y in sol.positions:
            if not (0 < X <= dat.M and 0 < Y <= dat.N):
                self.break_WA()
            if abs(X-X0) != abs(Y-Y0):
                self.break_WA()
            X0, Y0 = X, Y
        if abs(X0-dat.X2) != abs(Y0-dat.Y2):
            self.break_WA()
        self.break_OK()

###
### EOF
##########################################################################
