##########################################################################
### cars.plugin.py
###

class Cars(Task):

    id = 'CARS'

    tests = [
        Test(id='01', time=1.0, score=1,
            dat=Dat(A=90.0, V1=-3.0, V2=-6.0, S1=7.0, S2=8.0), chk=Chk(X=2.68328157299975)),
	Test(id='02', time=1.0, score=1,
            dat=Dat(A=90.0, V1=-1935.487, V2=-253.97, S1=-800.0, S2=-600.0), chk=Chk(X=1000.0)),
	Test(id='03', time=1.0, score=1,
            dat=Dat(A=90.0, V1=-1003.567, V2=904.468, S1=1003.567, S2=-904.468), chk=Chk(X=0.0)),
	Test(id='04', time=1.0, score=1,
            dat=Dat(A=90.0, V1=-1001.1, V2=-53.8, S1=1000.67, S2=-253.258), chk=Chk(X=306.5924784)),
	Test(id='05', time=1.0, score=1,
            dat=Dat(A=2.0, V1=-333.0, V2=-769.0, S1=234.0, S2=456.0), chk=Chk(X=2.2472531022)),        
	Test(id='06', time=1.0, score=1,
            dat=Dat(A=35.0, V1=137.5, V2=98.6, S1=127.8, S2=3987.536), chk=Chk(X=3835.6429242)),
	Test(id='07', time=1.0, score=2,
            dat=Dat(A=85.0, V1=93.654, V2=56.789, S1=34.56, S2=-44.3789), chk=Chk(X=58.5766843869203)),
	Test(id='08', time=1.0, score=2,
            dat=Dat(A=30.2, V1=42.56, V2=-2.345, S1=-42.56, S2=2.345), chk=Chk(X=0.000000000000000000328)),
	Test(id='09', time=1.0, score=2,
            dat=Dat(A=124.0, V1=-34.0, V2=45.0, S1=-67.0, S2=-89.0), chk=Chk(X=71.603465504)),
	Test(id='10', time=1.0, score=2,
            dat=Dat(A=134.0, V1=453.7, V2=-456.87, S1=2534.45, S2=-1004.569), chk=Chk(X=3312.0745227)),
	Test(id='11', time=1.0, score=2,
            dat=Dat(A=177.59, V1=444.678, V2=-3333.456, S1=56789.7, S2=333.5), chk=Chk(X=56456.49672041)),        
	Test(id='12', time=1.0, score=2,
            dat=Dat(A=91.5, V1=44.6738, V2=33.456, S1=-56789.7, S2=-333.5), chk=Chk(X=33346.92832)),
	Test(id='13', time=1.0, score=2,
            dat=Dat(A=120.0, V1=8.0, V2=0.0, S1=4.0, S2=3.0), chk=Chk(X=3.6055512755)),
	] 

    eps = 1.0e-4

    def write_input(self, dat):
        self.write_line(dat.A, dat.V1, dat.V2, dat.S1, dat.S2)

    def read_output(self, dat):
        X = self.read_line(float)
        return Sol(X=X)
    
    def check(self, dat, chk, sol):
        if abs(sol.X - chk.X) > self.eps:
            self.break_WA()
        self.break_OK()

###
### EOF
##########################################################################
